#include <iostream>
using namespace std;

int desiredMove = 0;
int currentMove = 0;

int numOfTransfers(int n){
	if(n==0) return 0;
	if(n==1) return 1;
	return 2*numOfTransfers(n-1) + 1;
}

void towersOfHanoi(char source, char mid, char dest, int n){
	if(n>0){
		int a = numOfTransfers(n-1);
		if(a<desiredMove-currentMove){
			currentMove+=a;
			currentMove++;
			if(currentMove == desiredMove){
				cout << source << " to "<< dest << " (Disk" << n << ")" << endl;
			}
			towersOfHanoi(mid,source,dest,n-1);
		}
		else{
			towersOfHanoi(source, dest, mid, n-1);
		}
		
	}
}
int main(){
	int n;
	cout << "Please enter the number of disks" << endl;
	cin >> n;
	cout << "Please enter the rank of the transfer you wish to display" << endl;
	cin >> desiredMove;
	towersOfHanoi('A','B','C',n);
	return 0;
}


